;**********************************************************************************************
; 31/15 Bit Unsigned Fixed Point Divide 31/15 -> 31.15
; ADD and SUBTRACT optimized for ADDWFC and SUBWFB instructions 03.2013 by Teemo Berkis
;for extended 14bit instruction set only!
;
UDIV3115L       macro
;       Max Timing:     9+6*17+16+16+6*17+16+16+6*17+16+16+6*17+16+8 = 537 clks
;       Min Timing:     9+6*16+15+15+6*16+15+15+6*16+15+15+6*16+15+3 = 501 clks
;       PM: 157                                 DM: 9
                MOVF            BARGB1,W
                SUBWF           REMB1, F
                MOVF            BARGB0,W
                SUBWFB           REMB0, F
                RLF             AARGB0, F
                MOVLW           7
                MOVWF           LOOPCOUNT
LOOPU3115A      RLF             AARGB0,W
                RLF             REMB1, F
                RLF             REMB0, F
                MOVF            BARGB1,W
                BTFSS           AARGB0,LSB
                GOTO            UADD15LA
                SUBWF           REMB1, F
                MOVF            BARGB0,W
                SUBWFB           REMB0, F

                GOTO            UOK15LA
UADD15LA        ADDWF           REMB1, F
                MOVF            BARGB0,W
                ADDWFC           REMB0, F
        
UOK15LA         RLF             AARGB0, F
                DECFSZ          LOOPCOUNT, F
                GOTO            LOOPU3115A
                RLF             AARGB1,W
                RLF             REMB1, F
                RLF             REMB0, F
                MOVF            BARGB1,W
                BTFSS           AARGB0,LSB
                GOTO            UADD15L8
                SUBWF           REMB1, F
                MOVF            BARGB0,W
                SUBWFB           REMB0, F
                GOTO            UOK15L8
UADD15L8        ADDWF           REMB1, F
                MOVF            BARGB0,W
                ADDWFC           REMB0, F
        
UOK15L8         RLF             AARGB1, F
                MOVLW           7
                MOVWF           LOOPCOUNT
LOOPU3115B      RLF             AARGB1,W
                RLF             REMB1, F
                RLF             REMB0, F
                MOVF            BARGB1,W
                BTFSS           AARGB1,LSB
                GOTO            UADD15LB
                SUBWF           REMB1, F
                MOVF            BARGB0,W
                SUBWFB           REMB0, F
                GOTO            UOK15LB
UADD15LB        ADDWF           REMB1, F
                MOVF            BARGB0,W
                ADDWFC           REMB0, F
        
UOK15LB         RLF             AARGB1, F
                DECFSZ          LOOPCOUNT, F
                GOTO            LOOPU3115B
                RLF             AARGB2,W
                RLF             REMB1, F
                RLF             REMB0, F
                MOVF            BARGB1,W
                BTFSS           AARGB1,LSB
                GOTO            UADD15L16
                SUBWF           REMB1, F
                MOVF            BARGB0,W
                SUBWFB           REMB0, F
                GOTO            UOK15L16
UADD15L16       ADDWF           REMB1, F
                MOVF            BARGB0,W
                ADDWFC           REMB0, F
        
UOK15L16        RLF             AARGB2, F
                MOVLW           7
                MOVWF           LOOPCOUNT
LOOPU3115C      RLF             AARGB2,W
                RLF             REMB1, F
                RLF             REMB0, F
                MOVF            BARGB1,W
                BTFSS           AARGB2,LSB
                GOTO            UADD15LC
                SUBWF           REMB1, F
                MOVF            BARGB0,W
                SUBWFB           REMB0, F
                GOTO            UOK15LC
UADD15LC        ADDWF           REMB1, F
                MOVF            BARGB0,W
                ADDWFC           REMB0, F
        
UOK15LC         RLF             AARGB2, F
                DECFSZ          LOOPCOUNT, F
                GOTO            LOOPU3115C
                RLF             AARGB3,W
                RLF             REMB1, F
                RLF             REMB0, F
                MOVF            BARGB1,W
                BTFSS           AARGB2,LSB
                GOTO            UADD15L24
                SUBWF           REMB1, F
                MOVF            BARGB0,W
                SUBWFB           REMB0, F
                GOTO            UOK15L24
UADD15L24       ADDWF           REMB1, F
                MOVF            BARGB0,W
                ADDWFC           REMB0, F
        
UOK15L24        RLF             AARGB3, F
                MOVLW           7
                MOVWF           LOOPCOUNT
LOOPU3115D      RLF             AARGB3,W
                RLF             REMB1, F
                RLF             REMB0, F
                MOVF            BARGB1,W
                BTFSS           AARGB3,LSB
                GOTO            UADD15LD
                SUBWF           REMB1, F
                MOVF            BARGB0,W
                SUBWFB           REMB0, F
                GOTO            UOK15LD
UADD15LD        ADDWF           REMB1, F
                MOVF            BARGB0,W
                ADDWFC           REMB0, F
        
UOK15LD         RLF             AARGB3, F
                DECFSZ          LOOPCOUNT, F
                GOTO            LOOPU3115D
                BTFSC           AARGB3,LSB
                GOTO            UOK15L
                MOVF            BARGB1,W
                ADDWF           REMB1, F
                MOVF            BARGB0,W
                ADDWFC           REMB0, F
UOK15L
                endm
;**********************************************************************************************
        
;       31/15 Bit Unsigned Fixed Point Divide 31/15 -> 31.15
;       Input:  31 bit unsigned fixed point dividend in AARGB0, AARGB1,AARGB2,AARGB3
;               15 bit unsigned fixed point divisor in BARGB0, BARGB1
;       Use:    CALL    FXD3115U
;       Output: 31 bit unsigned fixed point quotient in AARGB0, AARGB1,AARGB2,AARGB3
;               15 bit unsigned fixed point remainder in REMB0, REMB1
;       Result: AARG, REM  <--  AARG / BARG
;       Max Timing:     2+537+2 = 541 clks
;       Min Timing:     2+501+2 = 505 clks
;       PM: 2+157+1 = 160               DM: 9
FXD3115U        CLRF            REMB0
                CLRF            REMB1
                UDIV3115L
                RETLW           0x00
;**********************************************************************************************