;**********************************************************************************************
; 31/15 Bit Unsigned Fixed Point Divide 31/15 -> 31.15
; ADD and SUBTRACT optimized for ADDWFC and SUBWFB instructions 03.2013 by Teemo Berkis
;for extended 14bit instruction set only!
;09.2015 changed variable names to multi byte variables (AARG,AARG+1,AARG+2,AARG+3) AARG is MSB (big endian)
;	PIC16F1824 peal testitud, ttab
;
divide      UDATA
LOOPCOUNT   res     1
AARG        res     4
BARG        res     2
REM         res     2

#define LSB	0		;least significant bit definition

UDIV3115L       macro
;       Max Timing:     9+6*17+16+16+6*17+16+16+6*17+16+16+6*17+16+8 = 537 clks
;       Min Timing:     9+6*16+15+15+6*16+15+15+6*16+15+15+6*16+15+3 = 501 clks
;       PM: 157                                 DM: 9
				CLRF            REM
                CLRF            REM+1
                MOVF            BARG+1,W
                SUBWF           REM+1, F
                MOVF            BARG,W
                SUBWFB           REM, F
                RLF             AARG, F
                MOVLW           7
                MOVWF           LOOPCOUNT
LOOPU3115A      RLF             AARG,W
                RLF             REM+1, F
                RLF             REM, F
                MOVF            BARG+1,W
                BTFSS           AARG,LSB
                GOTO            UADD15LA
                SUBWF           REM+1, F
                MOVF            BARG,W
                SUBWFB           REM, F

                GOTO            UOK15LA
UADD15LA        ADDWF           REM+1, F
                MOVF            BARG,W
                ADDWFC           REM, F
        
UOK15LA         RLF             AARG, F
                DECFSZ          LOOPCOUNT, F
                GOTO            LOOPU3115A
                RLF             AARG+1,W
                RLF             REM+1, F
                RLF             REM, F
                MOVF            BARG+1,W
                BTFSS           AARG,LSB
                GOTO            UADD15L8
                SUBWF           REM+1, F
                MOVF            BARG,W
                SUBWFB           REM, F
                GOTO            UOK15L8
UADD15L8        ADDWF           REM+1, F
                MOVF            BARG,W
                ADDWFC           REM, F
        
UOK15L8         RLF             AARG+1, F
                MOVLW           7
                MOVWF           LOOPCOUNT
LOOPU3115B      RLF             AARG+1,W
                RLF             REM+1, F
                RLF             REM, F
                MOVF            BARG+1,W
                BTFSS           AARG+1,LSB
                GOTO            UADD15LB
                SUBWF           REM+1, F
                MOVF            BARG,W
                SUBWFB           REM, F
                GOTO            UOK15LB
UADD15LB        ADDWF           REM+1, F
                MOVF            BARG,W
                ADDWFC           REM, F
        
UOK15LB         RLF             AARG+1, F
                DECFSZ          LOOPCOUNT, F
                GOTO            LOOPU3115B
                RLF             AARG+2,W
                RLF             REM+1, F
                RLF             REM, F
                MOVF            BARG+1,W
                BTFSS           AARG+1,LSB
                GOTO            UADD15L16
                SUBWF           REM+1, F
                MOVF            BARG,W
                SUBWFB           REM, F
                GOTO            UOK15L16
UADD15L16       ADDWF           REM+1, F
                MOVF            BARG,W
                ADDWFC           REM, F
        
UOK15L16        RLF             AARG+2, F
                MOVLW           7
                MOVWF           LOOPCOUNT
LOOPU3115C      RLF             AARG+2,W
                RLF             REM+1, F
                RLF             REM, F
                MOVF            BARG+1,W
                BTFSS           AARG+2,LSB
                GOTO            UADD15LC
                SUBWF           REM+1, F
                MOVF            BARG,W
                SUBWFB           REM, F
                GOTO            UOK15LC
UADD15LC        ADDWF           REM+1, F
                MOVF            BARG,W
                ADDWFC           REM, F
        
UOK15LC         RLF             AARG+2, F
                DECFSZ          LOOPCOUNT, F
                GOTO            LOOPU3115C
                RLF             AARG+3,W
                RLF             REM+1, F
                RLF             REM, F
                MOVF            BARG+1,W
                BTFSS           AARG+2,LSB
                GOTO            UADD15L24
                SUBWF           REM+1, F
                MOVF            BARG,W
                SUBWFB           REM, F
                GOTO            UOK15L24
UADD15L24       ADDWF           REM+1, F
                MOVF            BARG,W
                ADDWFC           REM, F
        
UOK15L24        RLF             AARG+3, F
                MOVLW           7
                MOVWF           LOOPCOUNT
LOOPU3115D      RLF             AARG+3,W
                RLF             REM+1, F
                RLF             REM, F
                MOVF            BARG+1,W
                BTFSS           AARG+3,LSB
                GOTO            UADD15LD
                SUBWF           REM+1, F
                MOVF            BARG,W
                SUBWFB           REM, F
                GOTO            UOK15LD
UADD15LD        ADDWF           REM+1, F
                MOVF            BARG,W
                ADDWFC           REM, F
        
UOK15LD         RLF             AARG+3, F
                DECFSZ          LOOPCOUNT, F
                GOTO            LOOPU3115D
                BTFSC           AARG+3,LSB
                GOTO            UOK15L
                MOVF            BARG+1,W
                ADDWF           REM+1, F
                MOVF            BARG,W
                ADDWFC           REM, F
UOK15L
                endm
;**********************************************************************************************
        
;       31/15 Bit Unsigned Fixed Point Divide 31/15 -> 31.15
;       Input:  31 bit unsigned fixed point dividend in AARG, AARG+1,AARG+2,AARG+3
;														AARG res	4
;               15 bit unsigned fixed point divisor in BARG, BARG+1
;														BARG 	res	2
;       Use:    CALL    FXD3115U
;       Output: 31 bit unsigned fixed point quotient in AARG, AARG+1,AARG+2,AARG+3
;               15 bit unsigned fixed point remainder in REM, REM+1
;														REM  res 2
;       Result: AARG, REM  <--  AARG / BARG
;       Max Timing:     2+537+2 = 541 clks
;       Min Timing:     2+501+2 = 505 clks
;       PM: 2+157+1 = 160               DM: 9
;usage example:
;FXD3115U     
;                UDIV3115L
;                RETLW           0x00

;**********************************************************************************************